
-- gives book a grab
-- similar to bfdia 5b i think

freeslot("MT_BOOK_LAZYMOMENT")--, "SPR_HOLD", "SPR_HOWA", "SPR_HOFA", "SPR_HODO")

mobjinfo[MT_BOOK_LAZYMOMENT] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 64*FU,
	height = 64*FU,
	flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
}

local function initializeVars(p)
	p.bookholding = false
	p.bookholdmo = nil
	p.bookc1held = 0
	p.bookc2held = 0
end

freeslot("SPR2_HOLD", "S_BOOK_HOLD", "SPR2_HOWA", "S_BOOK_HOLDWALK", "SPR2_HOFA", "S_BOOK_HOLDJUMP", "SPR2_HODO", "S_BOOK_HOLDFALL")

states[S_BOOK_HOLD] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOLD,
	tics = -1,
	nextstate = S_BOOK_HOLD
}

states[S_BOOK_HOLDWALK] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOWA|FF_ANIMATE,
	tics = -1,
	nextstate = S_BOOK_HOLDWALK,
	var1 = N,
	var2 = 2
}

states[S_BOOK_HOLDJUMP] = {
	sprite = SPR_PLAY,
	frame = SPR2_HOFA,
	tics = -1,
	nextstate = S_BOOK_HOLDJUMP
}

states[S_BOOK_HOLDFALL] = {
	sprite = SPR_PLAY,
	frame = SPR2_HODO,
	tics = -1,
	nextstate = S_BOOK_HOLDFALL
}

addHook("PlayerSpawn", initializeVars)

local function canGrab(p)
	if P_PlayerInPain(p)
	or p.playerstate == PST_DEAD
		return false
	end
	return true
end

local function shouldHurt(pmo, pmo2)
	local p = pmo.player
	local p2 = pmo2.player
	
	local ff = CV_FindVar("friendlyfire").value
	
	--if (G_CoopGametype() and ff == 1)
	if (G_RingSlingerGametype() and not G_TagGametype() and not G_GametypeHasTeams())
	or G_CompetitionGametype()
	or (G_GametypeHasTeams() and p2.ctfteam ~= p.ctfteam)
	or (G_TagGametype() and (p2.pflags & PF_TAGIT))
	or ff == 1
		return true
	end

	return false
end

local function skinCarry(s)
	if s == "book"
	or s == "match"
		return true
	end
	return false
end

local function throwCarry(p)
	local enmy = p.bookholdmo
	p.bookholding = false
	if (enmy.player and enmy.player.valid)
		enmy.angle = enmy.player.drawangle
	end
	if p.speed < 16*FU
		P_InstaThrust(enmy, enmy.angle, 16*FU)
	else
		P_InstaThrust(enmy, enmy.angle, 16*FU+FixedDiv(p.speed, FixedDiv(15, 10)))
	end
	P_SetObjectMomZ(enmy, 7*FU)
end

addHook("PostThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid)
		or not skinCarry(p.mo.skin) then
			if p.bookholding
			and p.bookholdmo then
				throwCarry(p)
			end
			continue
		end
		
		if not p.bookholding then
			if p.mo.state >= S_BOOK_HOLD
			and p.mo.state <= S_BOOK_HOLDFALL then
				p.mo.state = S_PLAY_STND
			end
			
			if p.bookholdmo then
				local enmy = p.bookholdmo
				enmy.bookthrown = true
				enmy.flags = 0
				if enmy.info.book3dbox
					enmy.flags = $1|MF_SOLID
				end
				if (enmy.player and enmy.player.valid)
				and not shouldHurt(p.mo, enmy)
				and enmy.player.bot == 0 then
					enmy.player.pflags = $1|PF_SPINNING
					enmy.state = S_PLAY_ROLL
				end
				local boxthing = P_SpawnMobj(enmy.x, enmy.y, enmy.z, MT_BOOK_LAZYMOMENT)
				boxthing.target = enmy
				p.bookholdmo = nil
			end
		
			if (p.cmd.buttons & BT_CUSTOM1)
			and not (p.lastbuttons & BT_CUSTOM1) then
				searchBlockmap("objects", function(_, mo)
					if not ((mo.flags & MF_ENEMY) or (mo.flags & MF_SCENERY) or (mo.flags & MF_MONITOR) or mo.type == MT_PLAYER or mo.info.bookgrabbable)
					or p.bookholdmo
					or not canGrab(p) then return end
					--or (p.pflags & PF_TAGIT) return end

					if R_PointToDist2(p.mo.x, p.mo.y, mo.x, mo.y) > 64*FU
					or p.mo.z > mo.z+mo.height
					or mo.z > p.mo.z+p.mo.height return end
					
					p.bookholdmo = mo
					p.bookholding = true
					mo.bookplyr = p.mo
					mo.bookoldflags = {
						[1] = mo.flags,
						[2] = mo.flags2,
						[3] = mo.eflags
					}
					mo.flags = MF_NOTHINK|MF_NOCLIP|MF_NOCLIPHEIGHT
					p.lastbuttons = $1|BT_CUSTOM1
					return true
				end, p.mo, p.mo.x-64*FU, p.mo.x+64*FU, p.mo.y-64*FU, p.mo.y+64*FU)
			end
		else
			local mo = p.bookholdmo
			if not (mo and mo.valid) then
				p.bookholding = false
				return
			end
			
			if not canGrab(p) then
				p.bookholding = false
				P_InstaThrust(mo, p.drawangle, 5*FU)
				return
			end
			
			if (mo.player and mo.player.valid) then
				mo.player.drawangle = p.drawangle
				mo.state = S_PLAY_PAIN
				if not shouldHurt(mo, p.mo)
				and (mo.player.cmd.buttons & BT_JUMP) then
					mo.flags = mo.bookoldflags[1]
					mo.flags2 = mo.bookoldflags[2]
					mo.eflags = mo.bookoldflags[3]
					if (p.mo.eflags & MFE_VERTICALFLIP)
						mo.eflags = $1|MFE_VERTICALFLIP
					else
						mo.eflags = $ & ~MFE_VERTICALFLIP
					end
					mo.player.pflags = $ & ~PF_JUMPED
					P_DoJump(mo.player, true)
					mo.momx = p.mo.momx
					mo.momy = p.mo.momy
					mo.momz = $+p.mo.momz
					p.bookholdmo = nil
					p.bookholding = false
					return
				end
			else
				mo.angle = p.drawangle
			end
			
			if p.powers[pw_carry] == CR_ROPEHANG then
				p.powers[pw_carry] = CR_NONE
				P_SetObjectMomZ(p.mo, -5*FU)
				P_InstaThrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), -p.speed)
			end
			
			local panimtable = {
				[PA_IDLE] = S_BOOK_HOLD,
				[PA_WALK] = S_BOOK_HOLDWALK,
				[PA_RUN] = S_BOOK_HOLDWALK,
				[PA_DASH] = S_BOOK_HOLDWALK,
				[PA_JUMP] = S_BOOK_HOLDJUMP,
				[PA_SPRING] = S_BOOK_HOLDJUMP,
				[PA_FALL] = S_BOOK_HOLDFALL
			}
			if p.mo.skin == "match"
				panimtable[PA_FALL] = S_BOOK_HOLDJUMP
			end
			
			if panimtable[p.panim] then
				local opanim = p.panim
				p.mo.state = panimtable[p.panim]
				p.panim = opanim
			end
			
			if (p.cmd.buttons & BT_CUSTOM1)
			and not (p.lastbuttons & BT_CUSTOM1) then
				throwCarry(p)
			elseif (p.cmd.buttons & BT_CUSTOM2)
			and not (p.lastbuttons & BT_CUSTOM2) then
				p.bookholding = false
				P_SetObjectMomZ(mo, FU)
			end
			
			if not P_IsObjectOnGround(p.mo)
			and not (p.mo.eflags & MFE_GOOWATER) then
				P_SetObjectMomZ(p.mo, -abs(FixedDiv(FixedDiv(mo.radius+mo.height, 112*FU), FU+FU/2)), true)
			end
			
			local radius = p.mo.radius
			if mo.info.book3dbox then
				radius = mo.radius
			end
			mo.eflags = p.mo.eflags
			P_MoveOrigin(mo, p.mo.x+P_ReturnThrustX(mo, p.drawangle, radius), p.mo.y+P_ReturnThrustY(mo, p.drawangle, radius), p.mo.z+p.mo.height/2)
		end
	end
end)

local function collidethesecond(enmy, mo)
	if not enmy.bookthrown
	or not (mo.flags & MF_SHOOTABLE)
	or mo == enmy.bookplyr return end
	
	if enmy.z > mo.z+mo.height
	or mo.z > enmy.z+enmy.height return end
	
	if ((enmy.player and enmy.player.valid) and not (mo.player and mo.player.valid))
		enmy.flags = enmy.bookoldflags[1]
		return
	end
	
	if (enmy.player and enmy.player.valid)
	and not shouldHurt(enmy, mo) return end
	
	if (enmy.player and enmy.player.valid)
		P_DamageMobj(mo, enmy)
		enmy.flags = enmy.bookoldflags[1]
		P_DamageMobj(enmy, mo)
	else
		P_DamageMobj(mo, enmy, enmy.bookplyr)
		enmy.flags = enmy.bookoldflags[1]
		P_DamageMobj(enmy, mo, enmy.bookplyr)
	end
end

addHook("MobjCollide", collidethesecond)
addHook("MobjMoveCollide", collidethesecond)

addHook("MobjDeath", function(mo)
	if not mo.bookthrown
	or not mo.bookplyr return end
	
	mo.bookplyr.player.bookholdmo = nil
end)

addHook("MobjThinker", function(mo)
	local enmy = mo.target
	/*local ang = R_PointToAngle
	local tx, ty = P_ReturnThrustX(mo, 
	local sec = R_PointInSubsector(mo.x+mo.momx, mo.y+mo.momy).sector
	if (sec and sec.valid)
	and sec.ffloors then
		print("hi")
		for fof in sec.ffloors() do
			if not (fof.flags & FOF_EXISTS)
			or not (fof.flags & FOF_BLOCKPLAYER)
			or not (fof.flags & FOF_BUSTUP) then continue end
			
			print("got past part 1")
			
			local th = fof.topheight
			local bh = fof.bottomheight
			if fof.t_slope then
				th = P_GetZAt(fof.t_slope, mo.x+mo.momx, mo.y+mo.momy)
			end
			if fof.b_slope then
				bh = P_GetZAt(fof.b_slope, mo.x+mo.momx, mo.y+mo.momy)
			end
			
			if mo.z+mo.height < bh
			or mo.z > th then continue end
			
			print("crumbleee")
			
			EV_CrumbleChain(sec, fof)
		end
	end*/
	
	if (enmy and enmy.valid)
		local pmo = enmy.bookplyr
		local p = pmo.player
		P_SetOrigin(mo, enmy.x, enmy.y, enmy.z)
		if abs(FixedDiv(FixedDiv(enmy.radius+enmy.height, 112*FU), FU+FU/2)) >= FU
			P_SetObjectMomZ(enmy, -abs(FixedDiv(FixedDiv(enmy.radius+enmy.height, 112*FU), FU+FU/2)), true)
		end
		if P_IsObjectOnGround(enmy)
			enmy.flags = enmy.bookoldflags[1]
			enmy.flags2 = enmy.bookoldflags[2]
			enmy.eflags = enmy.bookoldflags[3]
			if (pmo.eflags & MFE_VERTICALFLIP)
				enmy.eflags = $1|MFE_VERTICALFLIP
			else
				enmy.eflags = $ & ~MFE_VERTICALFLIP
			end
			enmy.bookthrown = false
			S_StartSound(enmy, sfx_s3k4c)
			for i = 1, 16 do
				local dust = P_SpawnMobj(enmy.x, enmy.y, enmy.z, MT_SPINDUST)
				dust.angle = i*ANGLE_22h
				P_InstaThrust(dust, dust.angle, 16*FU)
				dust.scalespeed = FU/16
				dust.destscale = 0
			end
			P_RemoveMobj(mo)
			return
		end
	else
		P_RemoveMobj(mo)
		return
	end
end, MT_BOOK_LAZYMOMENT)