
-- hud stuff
-- yay :D

local cachedFont = {} -- so we can have more performance i think

local symbt = { -- why did past me do this :P
	["."] = "DOT"
}

local function draw5BString(v, x, y, scale, string, flags, alignment)
	if v == nil
	or x == nil
	or y == nil
	or string == nil return end
	
	scale = $ or FU
	flags = $ or 0
	alignment = $ or "left"
	string = tostring($)
	
	local len = string.len(string)
	local prevX = x
	for i = 1, len do
		local curLet = string.sub(string, i, i)
		local size = ((string.upper(curLet) == curLet) and "U") or "L"
		
		if symbt[curLet]
			curLet = symbt[$]
			size = ""
		end
		
		if tonumber(curLet) ~= nil size = "" end
		
		--local ltr = v.cachePatch("5BFNT"+curLet+size)
		if not (cachedFont["5BFNT"+curLet+size] and cachedFont["5BFNT"+curLet+size].valid) then
			cachedFont["5BFNT"+curLet+size] = v.cachePatch("5BFNT"+curLet+size)
		end
		local ltr = cachedFont["5BFNT"+curLet+size]
		local sdraw = true
		
		if curLet == " "
		or curLet == ""
			sdraw = false
		end
		
		if sdraw
			v.drawScaled(prevX, y, scale, ltr, flags)
			prevX = $+(ltr.width*scale)
		else
			prevX = $+(8*scale)
		end
	end
end

local intertic = 0 -- i swear this will end up resynching somehow D:
local stagefailed
local intspec = {}
local function skinCheck(skin)
	skin = skins[$].name
	return (skin == "book" or skin == "icecube" or skin == "match")
end

addHook("ThinkFrame", function()
	if not displayplayer
	and not secondarydisplayplayer return end
	
	intertic = 0
	stagefailed = nil
	intspec = {}
	local p = displayplayer or secondarydisplayplayer
	if not (p.mo and p.mo.valid) then return end
	
	if not skinCheck(p.mo.skin)
		if not hud.enabled("lives")
		and p.fbhudactive -- f stands for five since uhhh i cant do 5b
			hud.enable("lives")
			hud.enable("coopemeralds")
			p.fbhudactive = false
			--print(p.mo.skin)
		end
	elseif hud.enabled("lives")
	and not p.fbhudactive
		hud.disable("lives")
		hud.disable("coopemeralds")
		p.fbhudactive = true
	end
end)

addHook("HUD", function(v, p)
	if not (p.mo and p.mo.valid)
	or not skinCheck(p.mo.skin) return end -- gotta make this a function soon -- update: i did it!!
	
	local name = mapheaderinfo[gamemap].lvlttl
	local mnum = ((gamemap ~= tutorialmap) and gamemap) or 0
	local mstr = (G_CoopGametype() and mnum+". ") or ""
	local actnum = mapheaderinfo[gamemap].actnum
	local actstr = ((actnum ~= 0) and (" act "+actnum)) or ""
	
	draw5BString(v, 4*FU, 184*FU, FU/2, mstr+name+actstr, V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS)
end, "game")

if not BASEVIDWIDTH then -- pre 2.2.14 safe-check :P
	local BASEVIDWIDTH = 320
	local BASEVIDHEIGHT = 200
end
local cachedToken
local emeraldPos = {
	[0] = {
		x = (BASEVIDWIDTH/2)-8,
		y = (BASEVIDHEIGHT/3)-32,
	},
	[1] = {
		x = (BASEVIDWIDTH/2)-8+24,
		y = (BASEVIDHEIGHT/3)-16
	},
	[2] = {
		x = (BASEVIDWIDTH/2)-8+24,
		y = (BASEVIDHEIGHT/3)+16
	},
	[3] = {
		x = (BASEVIDWIDTH/2)-8,
		y = (BASEVIDHEIGHT/3)+32
	},
	[4] = {
		x = (BASEVIDWIDTH/2)-8-24,
		y = (BASEVIDHEIGHT/3)+16
	},
	[5] = {
		x = (BASEVIDWIDTH/2)-8-24,
		y = (BASEVIDHEIGHT/3)-16
	},
	[6] = {
		x = (BASEVIDWIDTH/2)-8,
		y = (BASEVIDHEIGHT/3)
	}
}

local emeraldslist = {
	[0] = SKINCOLOR_GREEN,
	[1] = SKINCOLOR_SIBERITE,
	[2] = SKINCOLOR_SAPPHIRE,
	[3] = SKINCOLOR_SKY,
	[4] = SKINCOLOR_TOPAZ,
	[5] = SKINCOLOR_FLAME,
	[6] = SKINCOLOR_SLATE,
	[7] = SKINCOLOR_BLACK
}

addHook("HUD", function(v)
	if not G_CoopGametype()
	or not displayplayer
	or not skinCheck(skins[displayplayer.skin].name) then return end
	
	if not (cachedToken and cachedToken.valid) then
		cachedToken = v.cachePatch("WINTOKEN")
	end
	local patch = cachedToken
	for i = 0, 6 do
		if not (emeralds & 1<<i) then continue end
		
		v.drawScaled(emeraldPos[i].x<<FRACBITS+patch.leftoffset<<FRACBITS, emeraldPos[i].y<<FRACBITS+patch.topoffset<<FRACBITS, FU, patch, 0, v.getColormap("sonic", emeraldslist[i]))
	end
end, "scores")

local function IsSpecialStage(mapnum) -- unnecessarily translate G_IsSpecialStage to lua, because why not?
	mapnum = $ ~= nil and $ or gamemap
	if (modeattacking)
		return false;
	end
	
	if (mapnum >= sstage_start and mapnum <= sstage_end)
		return true;
	end
	
	if (mapnum >= smpstage_start and mapnum <= smpstage_end)
		return true;
	end

	return false;
end

local function P_GetNextEmerald()
	if (gamemap >= sstage_start and gamemap <= sstage_end)
		return (gamemap - sstage_start);
	end
	if (gamemap >= smpstage_start or gamemap <= smpstage_end)
		return (gamemap - smpstage_start);
	end
	return 0;
end

local function handleSpec(v, spec)
	if spec == nil then
		spec = {}
	end
	
	// emerald bounce
	if (intertic <= 1)
	or spec.emeraldbounces == nil
	or spec.emeraldmomy == nil
	or spec.emeraldy == nil
		spec.emeraldbounces = 0;
		spec.emeraldmomy = 20;
		spec.emeraldy = -40;
	elseif (P_GetNextEmerald() < 7)
		if not (stagefailed)
			if (spec.emeraldbounces < 3)
				spec.emeraldmomy = $+1
				spec.emeraldy = $+spec.emeraldmomy;
				if (spec.emeraldy > 74)
					spec.emeraldbounces = $+1;
					spec.emeraldmomy = -($/2);
					spec.emeraldy = 74;
				end
			end
		else
			if (spec.emeraldy < (v.height/v.dupy)+16)
				spec.emeraldmomy = $+1
				spec.emeraldy = $+spec.emeraldmomy;
			end
			if (spec.emeraldbounces < 1 and spec.emeraldy > 74)
				spec.emeraldbounces = $+1;
				spec.emeraldmomy = -($/2);
				spec.emeraldy = 74;
			end
		end
	end
	
	return spec
end

local function drawEmerald(v, spec)
	local drawthistic = not (All7Emeralds(emeralds) and (intertic & 1));
	local emeraldx = 152 - 3*28;
	local em = P_GetNextEmerald();
	
	if not (cachedToken and cachedToken.valid) then
		cachedToken = v.cachePatch("WINTOKEN")
	end
	local patch = cachedToken
	if (em == 7)
		if not (stagefailed)
			local adjust = 2*(sin(FixedAngle((intertic + 1)<<(FRACBITS-4))));
			v.drawScaled((152<<FRACBITS)+(patch.leftoffset<<FRACBITS), (74<<FRACBITS) - adjust + (patch.topoffset<<FRACBITS), scale, patch, 0, v.getColormap("sonic", emeraldslist[em]));
		end
	elseif (em < 7)
		if (drawthistic)
			for i = 0, 7 do
				if ((i != em) and (emeralds & (1 << i)))
					v.draw(emeraldx+patch.leftoffset, 74+patch.topoffset, patch, 0, v.getColormap("sonic", emeraldslist[i]));
				end
				emeraldx = $+28;
			end
		end

		emeraldx = 152 + (em-3)*28;

		if (intertic > 1)
			if (stagefailed and spec.emeraldy < (v.height/v.dupy)+16)
				emeraldx = $+intertic - 6;
			end

			if (drawthistic)
				v.draw(emeraldx+patch.leftoffset, spec.emeraldy+patch.topoffset, patch, 0, v.getColormap("sonic", emeraldslist[em]));
			end
		end
	end
end

addHook("IntermissionThinker", function(sf)
	if not consoleplayer then return end
	local p = consoleplayer
	
	intertic = $+1
	stagefailed = sf
	
	if not skinCheck(p.skin)
	or not IsSpecialStage() then
		if p.bookinthud then
			--hud.enable("intermissiontitletext")
			hud.enable("intermissionemeralds")
			p.bookinthud = false
		end
	elseif not p.bookinthud then
		--hud.disable("intermissiontitletext")
		hud.disable("intermissionemeralds")
		p.bookinthud = true
	end
end)

addHook("HUD", function(v)
	if not consoleplayer then return end
	local p = consoleplayer
	
	if not skinCheck(p.skin)
	or not IsSpecialStage() then return end
	
	intspec = handleSpec(v, $)
	drawEmerald(v, intspec)
end, "intermission")